//+------------------------------------------------------------------+
//|                                  Pirson&Spearman_Correlation.mq4 |
//|                                                        DimDimych |
//|                            |
//|                     iPC_PriceLine.mq4  http://dmffx.com Integer | 
//|                                       for-good-letters@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "DimDimych"
#property link      "dm34@mail.ru"

#property indicator_separate_window
#property indicator_minimum -1
#property indicator_maximum 1
#property indicator_buffers 6
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Blue
#property indicator_color5 Gold
#property indicator_color6 Gold

#property  indicator_width1  2
#property  indicator_width2  2

//---- input parameters
extern string  TimeFrame        = "Current time frame";
extern bool    Pearson_Spearman_Correlation =  false;
extern int     PCPeriod_fast    =  8;   // 
extern int     PCPeriod_slow    =  12;   // 
extern int     SmPeriod_fast    =  4;   // 
extern int     SmPeriod_slow    =  4;   // 
extern int     PCPrice          =  0;    // : 0-Close, 1-Open, 2-High, 3-Low, 4-Median, 5-Typical, 6-Weighted
extern double  Level            =  0.7;  //  
extern double  Level_Ex         =  0.6;  //  
extern int     nb               =  0;
extern bool    alert            =  false;
extern bool    DisplayArrows    =  true;
extern int     nStopLossRange   =  5; // draw S/L line in last N bars min/max
extern color   colLong          = Lime;          // color for long lines
extern color   colShort         = Red;             // color for short lines
extern int     width            = 1;
extern bool    ArrowsOnFirstBar = true;
//---- buffers
double Buf_Fast[],Buf_Slow[];
double Buf_Long[],Buf_Short[];
double Buf_Long_Ex[],Buf_Short_Ex[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;
double ind1[],ind2[];
string sPrefix;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(8);
   SetIndexStyle(0,DRAW_LINE,0,2);
   SetIndexBuffer(0,Buf_Fast);
   
   SetIndexStyle(1,DRAW_LINE,0,2); 
   SetIndexBuffer(1,Buf_Slow);

   SetIndexBuffer(2, Buf_Long);
   SetIndexBuffer(3, Buf_Long_Ex);
   SetIndexBuffer(4, Buf_Short);
   SetIndexBuffer(5, Buf_Short_Ex);
    
   SetIndexStyle(2, DRAW_ARROW,0,1);
   SetIndexStyle(3, DRAW_ARROW,0,2);
   SetIndexStyle(4, DRAW_ARROW,0,1);
   SetIndexStyle(5, DRAW_ARROW,0,2);
    
   SetIndexArrow(2, 233);
   SetIndexArrow(3, 251);
   SetIndexArrow(4, 234);
   SetIndexArrow(5, 251);
   SetIndexBuffer(6, ind1);   
   SetIndexBuffer(7, ind2);

      
   SetLevelValue(0,Level); SetLevelValue(1,-Level);
   SetLevelValue(2,Level_Ex); SetLevelValue(3,-Level_Ex);
   SetLevelStyle(2,0,Silver);
     
   SetIndexDrawBegin(0,PCPeriod_fast);
   SetIndexDrawBegin(1,PCPeriod_slow);
   SetIndexLabel(0,"fast");
   SetIndexLabel(1,"slow");
   SetIndexLabel(2, "long");
   SetIndexLabel(3, "long exit");
   SetIndexLabel(4, "short");
   SetIndexLabel(5, "short exit"); 

   IndicatorDigits(2);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);

   if(Pearson_Spearman_Correlation)
    sPrefix = timeFrameToString(timeFrame)+"  Pearson_Correlation "+"("+PCPeriod_fast+","+PCPeriod_slow+")";
   else
    sPrefix = timeFrameToString(timeFrame)+"  Spearman_Correlation "+"("+PCPeriod_fast+","+PCPeriod_slow+")";
   
   IndicatorShortName(sPrefix);
   

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit(){
    int n = ObjectsTotal();
    for (int i = n - 1; i >= 0; i--) 
    {
     string sName = ObjectName(i);
	  if (StringFind(sName, sPrefix) == 0) 
	  {
	    ObjectDelete(sName);
	  }
    }
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  
  
  int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Buf_Fast[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               int shift = -1; if (ArrowsOnFirstBar) shift=1;
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);   
                   int x = iBarShift(NULL,timeFrame,Time[i+shift]);            
                   Buf_Fast[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Pearson_Spearman_Correlation,PCPeriod_fast,PCPeriod_slow,SmPeriod_fast,SmPeriod_slow,PCPrice,
                                     Level,Level_Ex,nb,alert,DisplayArrows,nStopLossRange,colLong,colShort,width,0,y);
                   Buf_Slow[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Pearson_Spearman_Correlation,PCPeriod_fast,PCPeriod_slow,SmPeriod_fast,SmPeriod_slow,PCPrice,
                                     Level,Level_Ex,nb,alert,DisplayArrows,nStopLossRange,colLong,colShort,width,1,y);
               if (x!=y)
               {
                   Buf_Long[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Pearson_Spearman_Correlation,PCPeriod_fast,PCPeriod_slow,SmPeriod_fast,SmPeriod_slow,PCPrice,
                                     Level,Level_Ex,nb,alert,DisplayArrows,nStopLossRange,colLong,colShort,width,2,y);
                   Buf_Long_Ex[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Pearson_Spearman_Correlation,PCPeriod_fast,PCPeriod_slow,SmPeriod_fast,SmPeriod_slow,PCPrice,
                                     Level,Level_Ex,nb,alert,DisplayArrows,nStopLossRange,colLong,colShort,width,3,y);
                   Buf_Short[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Pearson_Spearman_Correlation,PCPeriod_fast,PCPeriod_slow,SmPeriod_fast,SmPeriod_slow,PCPrice,
                                     Level,Level_Ex,nb,alert,DisplayArrows,nStopLossRange,colLong,colShort,width,4,y);
                   Buf_Short_Ex[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Pearson_Spearman_Correlation,PCPeriod_fast,PCPeriod_slow,SmPeriod_fast,SmPeriod_slow,PCPrice,
                                     Level,Level_Ex,nb,alert,DisplayArrows,nStopLossRange,colLong,colShort,width,5,y);
                }
               }
               return(0);
            }
  limit=Bars-IndicatorCounted()-1;
  
  if(Pearson_Spearman_Correlation)
  {
   Ind_PirsonPriceLine(ind1,PCPeriod_fast,PCPrice);
   Ind_PirsonPriceLine(ind2,PCPeriod_slow,PCPrice);
  }
  else
  {
   Ind_SpearmanPriceLine(ind1,PCPeriod_fast);
   Ind_SpearmanPriceLine(ind2,PCPeriod_slow);
  } 
    
  for(i=limit;i>=0;i--)
   {
    Buf_Fast[i]=iMAOnArray(ind1,Bars,SmPeriod_fast,0,MODE_SMA,i); 
    Buf_Slow[i]=iMAOnArray(ind2,Bars,SmPeriod_slow,0,MODE_SMA,i);
   } 
  
//-------------
  for(i=limit;i>=0;i--) 
  {
    Buf_Long[i]    =EMPTY_VALUE;
    Buf_Long_Ex[i] =EMPTY_VALUE;
    Buf_Short[i]   =EMPTY_VALUE;
    Buf_Short_Ex[i]=EMPTY_VALUE;
	
	if (Buf_Fast[i+1+nb] < Buf_Slow[i+1+nb] && Buf_Fast[i+nb] >= Buf_Slow[i+nb]) 
	{
	  if (Buf_Fast[i+nb] <= -Level || Buf_Slow[i+nb] <= -Level) 
	  {
		Buf_Long[i] = -Level-0.1;
	  }
  	  if (Buf_Fast[i+nb] <= -Level_Ex || Buf_Slow[i+nb] <= -Level_Ex) 
	  {
	   Buf_Short_Ex[i] = -Level_Ex;
	  }
  	}
	
	if (Buf_Fast[i+1+nb] > Buf_Slow[i+1+nb] && Buf_Fast[i+nb] <= Buf_Slow[i+nb]) 
	{
	    if (Buf_Fast[i+nb] >= Level || Buf_Slow[i+nb] >= Level) 
	    {
	     Buf_Short[i] = Level+0.1;
	    }
	    if (Buf_Fast[i+nb] >= Level_Ex || Buf_Slow[i+nb] >= Level_Ex) 
	    {
		  Buf_Long_Ex[i] = Level_Ex;
	    }
  	}
  	
	bool bLong = false;
	bool bShort = false;  	
//-------------
  if (DisplayArrows)
   {
    if(Buf_Long[i] == -Level-0.1)
     {
      DrawAr("up",i,colLong);
      bLong = true;
     }
    if(Buf_Short[i] ==Level+0.1)
     {
      DrawAr("dn",i,colShort);
      bShort =true;
     }
   //---
   if (bLong || bShort) 
	{
	  if (nStopLossRange > 0) 
	  {
		string sNameStopLossH=sPrefix+" SL H "+TimeToStr(Time[i],TIME_DATE|TIME_MINUTES);
		string sNameStopLossV=sPrefix+" SL V "+TimeToStr(Time[i],TIME_DATE|TIME_MINUTES);
		datetime t0 = Time[i];
		datetime ts = Time[i+nStopLossRange];
		datetime te = Time[i]+nStopLossRange*Period()*60;
		if (bLong) 
		{
		  double p = Low[iLowest(NULL, 0, MODE_LOW, nStopLossRange, i + 1)];
		  objLine(sNameStopLossH, ts, p, te, p, colLong);
		  objLine(sNameStopLossV, t0, p, t0, p + 3 * Point, colLong);
		} 
		else 
		{
		  p = High[iHighest(NULL, 0, MODE_HIGH, nStopLossRange, i + 1)];
		  objLine(sNameStopLossH, ts, p, te, p, colShort);
		  objLine(sNameStopLossV, t0, p, t0, p - 3 * Point, colShort);
		}
	  }
	 }
   }
    WindowRedraw();    
          
//-------------
}
//-------------
int flagval1 = 0; 
int flagval2 = 0;

if(alert) 
{// long signal
	if (Buf_Fast[2] < Buf_Slow[2] && Buf_Fast[1] >= Buf_Slow[1]) 
	{
	  if (Buf_Fast[1] <= -Level || Buf_Slow[1] <= -Level) 
	  {
		if(flagval1 == 0)
		{
		Alert(Symbol(),"PC BUY ", Period()," at ", Ask);
		flagval1 = 1; flagval2 = 0;
		}
	  }
  	} 
//**
	if (Buf_Fast[2] > Buf_Slow[2] && Buf_Fast[1] <= Buf_Slow[1]) 
	{
	 if (Buf_Fast[1] >= Level || Buf_Slow[1] >= Level) 
	  {
	  	 if(flagval2 == 0)
	    {
		 Alert(Symbol(),"PC SELL ", Period()," at ", Bid);
		 flagval1 = 0; flagval2 = 1;	     
	    }	     
	  }
  	}  	
}  	
//-------------  
  
   return(0);
}
//+------------------------------------------------------------------+

void Ind_PirsonPriceLine(double & aToBuf[],int aPeriod,int aPrice){
   int limit=Bars-IndicatorCounted()-1;
      for(int i=limit;i>=0;i--){
         double tValue;
            if(fPirsonPriceLine(i,aPeriod,aPrice,tValue)){
               aToBuf[i]=tValue;
            }
            else{
               aToBuf[i]=aToBuf[i+1];
            }
      }
}


bool fPirsonPriceLine(int aStartX, int aPeriod, int aPrice, double & aCorrelation){
   double SumXY=0;
   double SumXX=0;
   double SumYY=0;
   double SumY=0;
   double SumX=0;         
   int j;
   int xi;
      for(j=0,xi=aStartX;j<aPeriod;j++,xi++){
         double X=iMA(NULL,0,1,0,0,aPrice,xi);
         SumX+=X;  
         SumY+=j;  
         SumXX+=X*X;
         SumYY+=j*j;         
         SumXY+=X*j; 
      }
   double SXY=aPeriod*SumXY-SumY*SumX; 
   double SXXYY=(aPeriod*SumXX-SumX*SumX)*(aPeriod*SumYY-SumY*SumY);
      if (NormalizeDouble(SXXYY,8)!=0.0){
         aCorrelation=-SXY/(MathSqrt(MathAbs(SXXYY)));
         return(true);
      }  
   return(false);
}
//-------------------------
void Ind_SpearmanPriceLine(double & aToBuf[],int aPeriod){
    int limit;
    int counted_bars = IndicatorCounted();
    if (counted_bars > 0) 
    {counted_bars--;}
    
    limit = Bars - counted_bars;
   
    double data[];
    ArrayResize(data, aPeriod);
    
    for (int i = limit - 1; i >= 0; i--) 
    {
     copyData(data, i, aPeriod);
     int total = 0;	
      for (int j = 0; j < aPeriod; j++) 
	   {
	    int imax = ArrayMaximum(data);
	    total += (imax - j) * (imax - j);
	    data[imax] = 0;
	   }
	 aToBuf[i] = 1.0 - 6.0 * total / (aPeriod * (aPeriod * aPeriod - 1.0));
    }
}
//----
void copyData(double &data[], int i, int n)
{
    double high[],low[];
    
    if (PCPrice >= PRICE_MEDIAN) 
    {
     ArrayResize(high, n);
	  ArrayResize(low, n);
	  ArrayCopy(high, High, 0, i, n);
	  ArrayCopy(low, Low, 0, i, n);
	  ArrayCopy(data, Close, 0, i, n);
    }
    
    switch (PCPrice) 
    {
    case PRICE_CLOSE: ArrayCopy(data, Close, 0, i, n); break;
    case PRICE_OPEN:  ArrayCopy(data, Open, 0, i, n);	 break;
    case PRICE_HIGH:  ArrayCopy(data, High, 0, i, n);	 break;
    case PRICE_LOW:	 ArrayCopy(data, Low, 0, i, n);	 break;
	
    case PRICE_MEDIAN:
   	for (i=0; i<n; i++){data[i]=(high[i]+low[i])/2;} break;
	
    case PRICE_TYPICAL:
		for (i=0; i<n; i++){data[i]=(high[i]+low[i])/3;} break;
	
    case PRICE_WEIGHTED:
	   for (i=0; i<n; i++)
	   {data[i]=(high[i]+low[i]+data[i]*2)/4;}         break;
	
    default:
      Print("Warning: illegal PCPrice= ", PCPrice);
   	ArrayCopy(data, Close, 0, i, n);	break;
   }
}
//---------------
//----------------------------------------------------------------------
void DrawAr(string ssName, int i,color aColor)
{
    
    string sName=sPrefix+" "+ssName+" "+ TimeToStr(Time[i],TIME_DATE|TIME_MINUTES);
    //ObjectDelete(sName);    
    ObjectCreate(sName, OBJ_ARROW, 0, Time[i], 0);
    if(ssName=="up")
    {
    ObjectSet(sName, OBJPROP_ARROWCODE,  225);
    ObjectSet(sName, OBJPROP_PRICE1, Low[i]-5*Point);
    }
    if(ssName=="dn")
    {
    ObjectSet(sName, OBJPROP_ARROWCODE,  226);
    ObjectSet(sName, OBJPROP_PRICE1, High[i]+5*Point);
    }
    ObjectSet(sName, OBJPROP_COLOR, aColor);    
    ObjectSet(sName, OBJPROP_WIDTH, width);
} 
//---
void objLine(string sName, datetime ts, double ps, datetime te, double pe, color col,
	     bool bBack = true, bool bRay = false)
{
    ObjectCreate(sName, OBJ_TREND, 0, 0, 0, 0);
    ObjectSet(sName, OBJPROP_TIME1,  ts);
    ObjectSet(sName, OBJPROP_PRICE1, ps);
    ObjectSet(sName, OBJPROP_TIME2,  te);
    ObjectSet(sName, OBJPROP_PRICE2, pe);
    ObjectSet(sName, OBJPROP_COLOR, col);
    ObjectSet(sName, OBJPROP_WIDTH, width);
    ObjectSet(sName, OBJPROP_BACK, bBack);
    ObjectSet(sName, OBJPROP_RAY, bRay);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

